// Dec. 2013 - roadblock game - code by Emperor Katax - www.kataxco.com
// -----------------------------------------------------
// This class is responsible to move background image.  On " setDestination" , the final point get registered and in "moveit"
// background images move toward destination with speed of  " this.speed". 
// -----------------------------------------------------
function BackGRManager () {
		this.x = 0;
		this.y = 0;
		
		this.maxMaps = 0;
		this.map_images = new Array();
		
		// move 
		this.distancePro = 0;
		this.mainAngle = 0;
		this.mousX = 0;
		this.mousY = 0;
		this.playerX = 0;
		this.playerY = 0;
		this.playerX_start = 0;
		this.playerY_start = 0;
		this.speed = 1;
		
		this.moveGrowX = 0;
		this.moveGrowY = 0;
		
		this.startScrol = false;
		
}
// make image classes and set coordination of x
BackGRManager.prototype.addImage = function (imageArray) {
	for (var i = 0; i < imageArray.length; i++){
		this.map_images[i] = new BackGR_image(imageArray[i]);
		this.map_images[i].id = i;
		this.map_images[i].x = (i * 1000);
	}
	this.maxMaps = imageArray.length;
}


// draw images 
BackGRManager.prototype.draw = function (context, plX, plY, startGame, nogameOver) {
		for (var i = 0; i < this.maxMaps; i++){
			this.map_images[i].draw(context, plX, plY);
			if (startGame && nogameOver && (this.map_images[0].x  > -3200 )) this.map_images[i].x -= this.speed; // if startGame == true then background will scrol
		}
		//context.fillText(  "  mm:   " + this.map_images[0].x 	, 40, 40);
}


// get destination mouse coords
BackGRManager.prototype.setDestination = function ( mmx, mmy, plX, plY) {
	this.mousX = mmx;
	this.mousY = mmy;
	this.playerX = 512;
	this.playerY = plY;
	this.playerX_start = 512;
	this.playerY_start = plY;
}
// move background
BackGRManager.prototype.moveit = function (context) {
	this.distancePro = Math.sqrt(( this.mousX - this.playerX )*( this.mousX - this.playerX ) + ( this.mousY - this.playerY )*( this.mousY - this.playerY)); // distance
	this.mainAngle = Math.atan2( ( this.mousY - this.playerY ), ( this.mousX - this.playerX ) );// shoot angle
	
	if ( this.distancePro > (this.speed + .2) ) {							// check for end of move phase
		this.playerX += this.speed * Math.cos( this.mainAngle ) ;
		this.playerY += this.speed * Math.sin( this.mainAngle ) ;
		
		this.moveGrowX = this.speed * Math.cos( this.mainAngle ) ;
		this.moveGrowY = this.speed * Math.sin( this.mainAngle ) ;
		
		for (var i = 0; i < this.maxMaps; i++)			this.map_images[i].x -= this.speed * Math.cos( this.mainAngle ); // move phase
	}
	if (this.map_images[0].x > 0){ // fix first map, it should not move
		this.startScrol = false;
		//context.fillText(  "  <-- :  .. "	, this.mousX, this.mousY + 100);
	}
}
// set game speed
BackGRManager.prototype.setGameSpeed = function (speed) {
	this.speed = speed;
}
// reset
BackGRManager.prototype.reset = function (imageArray) {
		for (var i = 0; i < imageArray.length; i++){
			this.map_images[i].reset(imageArray[i]);
			this.map_images[i].x = (i * 1000);
		}
		//context.fillText(  "  mm:   " + this.map_images[0].x 	, 40, 40);
}
;

