// Dec. 2013 - roadblock game - code by Emperor Katax - www.kataxco.com
// -----------------------------------------------------
// This class is responsible for manage file names for game.
// At this level we just have background images and player avatar image.
// note: access data by xml or PHP
// -----------------------------------------------------
function FileData () {
	// map images
	this.map_stage_easy = 
	[ 
		["./images/maps/stage01/lev01/map-00.jpg","./images/maps/stage01/lev01/map-01.jpg","./images/maps/stage01/lev01/map-02.jpg","./images/maps/stage01/lev01/map-03.jpg","./images/maps/stage01/lev01/map-04.jpg"]
	,	["./images/maps/stage01/lev02/map-00.jpg","./images/maps/stage01/lev02/map-01.jpg","./images/maps/stage01/lev02/map-02.jpg","./images/maps/stage01/lev02/map-03.jpg","./images/maps/stage01/lev02/map-04.jpg"]
	,	["./images/maps/stage01/lev03/map-00.jpg","./images/maps/stage01/lev03/map-01.jpg","./images/maps/stage01/lev03/map-02.jpg","./images/maps/stage01/lev03/map-03.jpg","./images/maps/stage01/lev03/map-04.jpg"] 
	
	];
	this.map_stage_medium = 
	[ 
		["./images/maps/stage02/lev01/map-00.jpg","./images/maps/stage02/lev01/map-01.jpg","./images/maps/stage02/lev01/map-02.jpg","./images/maps/stage02/lev01/map-03.jpg","./images/maps/stage02/lev01/map-04.jpg"]
	,	["./images/maps/stage02/lev02/map-00.jpg","./images/maps/stage02/lev02/map-01.jpg","./images/maps/stage02/lev02/map-02.jpg","./images/maps/stage02/lev02/map-03.jpg","./images/maps/stage02/lev02/map-04.jpg"]
	,	["./images/maps/stage02/lev03/map-00.jpg","./images/maps/stage02/lev03/map-01.jpg","./images/maps/stage02/lev03/map-02.jpg","./images/maps/stage02/lev03/map-03.jpg","./images/maps/stage02/lev03/map-04.jpg"] 
	
	];
	this.map_stage_hard = 
	[ 
		["./images/maps/stage03/lev01/map-00.jpg","./images/maps/stage03/lev01/map-01.jpg","./images/maps/stage03/lev01/map-02.jpg","./images/maps/stage03/lev01/map-03.jpg","./images/maps/stage03/lev01/map-04.jpg"]
	,	["./images/maps/stage03/lev02/map-00.jpg","./images/maps/stage03/lev02/map-01.jpg","./images/maps/stage03/lev02/map-02.jpg","./images/maps/stage03/lev02/map-03.jpg","./images/maps/stage03/lev02/map-04.jpg"]
	,	["./images/maps/stage03/lev03/map-00.jpg","./images/maps/stage03/lev03/map-01.jpg","./images/maps/stage03/lev03/map-02.jpg","./images/maps/stage03/lev03/map-03.jpg","./images/maps/stage03/lev03/map-04.jpg"] 
	
	];
	
	this.map_images = new Array(	this.map_stage_easy, this.map_stage_medium, this.map_stage_hard );
	// player images
	//this.player_image = new Array(	"./images/player_01.png");
	this.player_image = new Array(	"./images/player-right.png", "./images/player-left.png", "./images/player-up.png", "./images/player-down.png"  );
	// message images
	this.msg_image = new Array(	"./images/msg-start.jpg", "./images/msg-over.jpg", "./images/msg-next.jpg", "./images/msg-end.jpg");
	this.map_Iterator = 0;
	// file name
	this.filename = "";
}

FileData.prototype.getData = function (type, id00, id01) {
  if (type == "player"){
		//this.filename = this.player_image[0];
		//return this.filename;
		return this.player_image;
  }
  if (type == "map"){
		return this.map_images[id00][id01];
		//return this.map_images_lvl1[0];
  }
  if (type == "msg"){
		return this.msg_image;
  }
};