// Dec. 2013 - roadblock game - code by Emperor Katax - www.kataxco.com
// -----------------------------------------------------
// This class is responsible to move player image.  On " setDestination" , the final point get registered and in "moveit"
// player image move toward destination with speed of  " this.speed". 
// -----------------------------------------------------
function Player (imageFile) {
		//if (radius === undefined) { radius = 40; }
		//if (color === undefined) { color = "#aaa"; }
		// coordinations
		this.x = 380;
		this.y = 400;
		
		this.imageShiftX = 0;	// shift image to be in center at the end of move
		this.imageShiftY = 0;
		
		this.mousX = 380;
		this.mousY = 400;
		this.imageX = 380;
		this.imageY = 400;
		
		this.distancePro = 0;		// distance between mouse and object
		this.mainAngle = 0;			// angle of movements
		this.fixFlag = false;		// control flag
		this.fixFlag_X = 0;			// control flag
		this.speed = 4;						// movement speed
		this.speed_addon = .2;		// movement speed add on
		this.speed_lock = 1;			// background lock speed
		//  image file
		//this.image = new Image();
		this.player_images = new Array();
		for (var i = 0; i < imageFile.length; i++){
			this.player_images[i] = new Image();
			this.player_images[i].src = imageFile[i];
		}
		
		this.moveInProgress = false;
		// player anim guid (righ = 0, left = 1,  up = 2, down = 3)
		this.playerAnim_Guid = 0; // "right" is default.
		this.playerAnim_dX = 0; // distance on x
		this.playerAnim_dY = 0; // distance on y
		
}
// get/set destination mouse coords
Player.prototype.setDestination = function ( mmx, mmy) {
	this.mousX = mmx;
	this.mousY = mmy;
	// check for player graphic
	this.playerAnim_dX = (this.x + 38) - mmx;
	this.playerAnim_dY = (this.y + 38) - mmy;
	// left and right
	if ( this.playerAnim_dX <= 0 ){
		this.playerAnim_Guid = 0;
	}else{
		this.playerAnim_Guid = 1;
	}
	// up and down
	if ( (Math.abs(this.playerAnim_dX) < Math.abs(this.playerAnim_dY)) && ( Math.abs(this.playerAnim_dY) > 12  ) ){
		if ( this.playerAnim_dY > 0 ){
			this.playerAnim_Guid = 2;
		}else{
			this.playerAnim_Guid = 3;
		}
	}
	
	
}
Player.prototype.getDestination = function () {
	return (this.x, this.y);
}
// move sequence
Player.prototype.moveit = function (context) {
	this.distancePro = Math.sqrt( 	( this.mousX - (this.x + this.imageShiftX) ) * ( this.mousX - (this.x + this.imageShiftX) ) + ( this.mousY - (this.y + this.imageShiftY) ) * ( this.mousY - (this.y + this.imageShiftY) ) );
	this.mainAngle = Math.atan2( ( this.mousY - (this.y + this.imageShiftY) ), ( this.mousX - (this.x + this.imageShiftX) ) );// shoot angle
	if ( this.distancePro > (this.speed + this.speed_addon) ) {							// check for end of move phase
		this.moveInProgress = true;
		this.x += this.speed * Math.cos( this.mainAngle ) ;											// x move phase
		this.y += this.speed * Math.sin( this.mainAngle ) ;											// y move phase
	}else{
		this.moveInProgress = false;
	}
	//context.fillText(  "  <-- :   " + Math.round(this.mousX)  + " .. " + Math.round(this.mousY)	, this.mousX, this.mousY);
}
// lock on background speed
Player.prototype.move_withBKGR = function (context) {
	this.x -= this.speed_lock;
	this.mousX = this.x + this.imageShiftX;
	this.mousY = this.y + this.imageShiftY;
	
}
// stop player move
Player.prototype.stopMove = function (context) {
	this.moveInProgress = false;
	this.mousX = this.x + this.imageShiftX;
	this.mousY = this.y + this.imageShiftY;
	
}
Player.prototype.XX = function () {
	return (this.x + this.imageShiftX);
}
Player.prototype.YY = function () {
	return (this.y + this.imageShiftY);
}
// add image to stage
Player.prototype.draw = function (context) {
			//context.drawImage(this.image, this.x, this.y);
			context.drawImage(this.player_images[this.playerAnim_Guid ], this.x, this.y);
}
Player.prototype.setGameSpeed = function (speed) {
	this.speed_lock = speed;
	this.speed = 3 + this.speed_lock; // basic formula for moving player forward and backward with same speed over background
}
//set player start point
Player.prototype.setplayerStartPoint = function (xx, yy) {
		// coordinations
		this.x = xx;
		this.y = yy;
		
		this.mousX = xx;
		this.mousY = yy;
		this.imageX = xx;
		this.imageY = yy;
}
;
